;;; Sierra Script 1.0 - (do not remove this comment)
(script# 507)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	Woods_Region 0
)

(local
	local0
)
(instance Woods_Region of Rgn
	(properties
		name "Woods Region"
	)
	
	(method (init)
		(if (== (Random 1 5) 4)
			(= gNewAct_4 (Act new:))
			(gNewAct_4
				view: 356
				ignoreHorizon:
				illegalBits: 0
				ignoreActors:
				setPri: 14
				setScript: ravenActions
			)
			(if (== (Random 1 2) 1)
				(gNewAct_4
					posn: 5 30
					xStep: 5
					yStep: 4
					setCycle: Fwd
					setMotion: MoveTo 339 20 gNewAct_4
					init:
				)
			else
				(gNewAct_4
					posn: 314 20
					xStep: 5
					yStep: 4
					setCycle: Fwd
					setMotion: MoveTo -20 40 gNewAct_4
					init:
				)
			)
		)
		(super init:)
	)
	
	(method (handleEvent pEvent)
		(if (pEvent claimed?) (return 1))
		(return
			(if (== (pEvent type?) evSAID)
				(cond 
					((Said 'look>')
						(cond 
							((Said '/boulder') (Print 507 0))
							((Said '/flora') (Print 507 1))
							((Said '/dirt,down') (Print 507 2))
							((Said '/bush') (Print 507 3))
							((Said '/grass') (Print 507 4))
							((Said '/blossom') (Print 507 5))
							((Said '/forest') (Print 507 6))
							((Said '/crow,bird,crow')
								(if (gCast contains: gNewAct_4)
									(Print 507 7)
								else
									(Print 507 8)
								)
							)
						)
					)
					((Said 'climb/boulder') (Print 507 9))
					((Said 'get/blossom') (Print 507 10))
					((Said 'climb/forest') (Print 507 11))
					((Said 'converse/crow,bird,crow')
						(if (gCast contains: gNewAct_4)
							(Print 507 12)
						else
							(Print 507 13)
						)
					)
					((Said 'get,capture/crow,bird,crow')
						(if (gCast contains: gNewAct_4)
							(Print 507 14)
						else
							(Print 507 15)
						)
					)
					((Said 'kiss/crow,bird,crow')
						(if (gCast contains: gNewAct_4)
							(Print 507 16)
						else
							(Print 507 15)
						)
					)
				)
			else
				0
			)
		)
	)
)

(instance ravenActions of Script
	(properties)
	
	(method (cue)
		(gNewAct_4 dispose:)
	)
)
