;;; Sierra Script 1.0 - (do not remove this comment)
(script# 14)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Game)
(use InvI)
(use Feature)

(public
	Room14 0
)

(local
	local0
)
(instance Room14 of Rm
	(properties
		picture 14
	)
	
	(method (init)
		(= north 8)
		(= south 20)
		(= east 15)
		(= west 13)
		(= horizon 68)
		(= global101 0)
		(if (<= (gEgo y?) horizon)
			(gEgo posn: (gEgo x?) (- horizon 2))
		)
		(if (and (== gPrevRoomNum 20) (> (gEgo x?) 209))
			(gEgo x: 209)
		)
		(super init:)
		(if global100 (gRoom overlay: 114))
		(= local0
			(+
				(* (- global160 global213) 60)
				(- global159 global214)
			)
		)
		(if
		(and ((Inv at: 9) ownedBy: 203) (>= local0 3))
			(= global118 (/ (= global118 (Random 1 300)) 100))
		)
		(if (== global118 2)
			((= gNewAct_2 (Act new:))
				view: 174
				loop: 2
				setCel: 0
				illegalBits: 0
				posn: 168 129
				init:
			)
		)
		(self setRegions: 506 516)
		(gEgo view: 2 init:)
		(if (== gPrevRoomNum 0) (gEgo posn: 149 188))
	)
	
	(method (handleEvent pEvent)
		(if (pEvent claimed?) (return 1))
		(return
			(if (== (pEvent type?) evSAID)
				(cond 
					(
						(or
							(Said 'look/around')
							(Said 'look/room')
							(Said 'look[<around][/!*]')
							(Said 'smell/blossom')
						)
						(Print 14 0)
					)
					((Said 'look/stump') (Print 14 1))
				)
			else
				0
			)
		)
	)
	
	(method (newRoom newRoomNumber)
		(if (gCast contains: gNewAct_2)
			(= global213 global160)
			(= global214 global159)
		)
		(super newRoom: newRoomNumber)
	)
)
